-- $Name:Код-10$
-- $Version:1.0$
-- $Author:casper_nn$


instead_version "1.9.1"

game.dsc = [[]];

game.codepage = 'UTF-8';
game.act = 'Не получается.';
game.inv = 'Гм.. Странная штука..';
game.use = 'Не сработает...';


require "para" 
--require "dash"
require "quotes"

require "dbg"
require "xact"
require "prefs"
require "theme"


dofile('core.lua');
dofile('game.lua');
dofile('thm.lua');



function init()
	--putf('debug_tool', stead.me());
	inv_clear()
	--game.enable_save = true
	game.enable_save = false

	prefs.ep2 =  prefs.ep2 or false;
	
	prefs.diff = prefs.diff or 2;
	prefs.stat = prefs.stat or {};
	prefs.completed = prefs.completed or {};
	
	if not prefs.completed[1] then 
		prefs.stat[1] = { ['battle_count'] = battle_count, ['losses_count'] = losses_count, ['frag_count']=frag_count, ['hm_count']=hm_count } 
	end
	
	thm.init()
	--thm.setgfx('mil')

end


function start()
	set_locale(lang)
	if loc_add~='' then set_locale(lang,loc_add) end
end


function xml_to_str(tbl)
	local k,v,r
	r=''
	for k,v in pairs(tbl) do
		if type(v) == 'table' then r =r..' <'..k..'>'..xml_to_str(v)..'</'..k..'> '
		else r = r..' ['..k..' = '..v..']'
		end	
	end	
	return r
end


---темы
mthemas = room {
	nam = 'Темы',
	disp = '',
	forcedsc = true,
	dsc = function(s)
		if ui_type == UIT_MENU then  return img('img/'..prefs.thm..'/'..'code10.png')..'^' else return true end
	end,
	--pic = '',
	obj = { 
			obj{
				nam = 'Стандартная'; dsc = function(s) if prefs.thm == 'std' then return txtc('>{'.._l('gui.std')..'}<^') else  return txtc('{'.._l('gui.std')..'}^') end; end; 
				act = function(s) thm.set('std') return true end
				};

			obj{
				nam = 'Милитари'; dsc = function(s)  if prefs.thm == 'mil' then return txtc('>{'.._l('gui.mil')..'}<^') else  return txtc('{'.._l('gui.mil')..'}^') end; end; 
				act = function(s) thm.set('mil') return true end
				};

				obj{
				nam = 'Назад'; dsc = function(s) return txtc('^{'.._l('gui.back')..'}^') end;
				act = function(s) walk(msettings)  end
				};

				
				
	}
};

---сложность
mdiff = room {
	nam = 'Сложность',
	disp = '',
	forcedsc = true,
	dsc = function(s)
		if ui_type == UIT_MENU then  return img('img/'..prefs.thm..'/'..'code10.png')..'^' else return true end
	end,
	--pic = '',
	obj = { 
			obj{
				nam = 'Тренировка'; dsc = function(s) if prefs.diff == 1 then return txtc('>{'.._l('gui.easy')..'}<^') else return txtc('{'.._l('gui.easy')..'}^') end; end; 
				act = function(s)  prefs.diff = 1 return true end
				};
			obj{
				nam = 'Сложно'; dsc = function(s) if prefs.diff == 2 then return txtc('>{'.._l('gui.normal')..'}<^') else return txtc('{'.._l('gui.normal')..'}^') end; end;
				act = function(s)  prefs.diff = 2  return true end
				};
			obj{
				nam = 'Очень трудно'; dsc = function(s) if prefs.diff == 3 then return txtc('>{'.._l('gui.hard')..'}<^') else return txtc('{'.._l('gui.hard')..'}^') end; end;
				act = function(s)  prefs.diff = 3  return true end
				};
				

				obj{
				nam = 'Назад'; dsc = function(s) return txtc('^{'.._l('gui.back')..'}^') end;
				act = function(s) walk(msettings)  end
				};

				
				
	}
};



--настройки
msettings = room {
	nam = 'Настройки',
	disp = '',
	forcedsc = true,
	dsc = function(s)
		if ui_type == UIT_MENU then  return img('img/'..prefs.thm..'/'..'code10.png')..'^' else return true end
	end,
	entered = function(s) 
				inv_clear();   
			end,
	--pic = '',
	obj = { 
			obj{
				nam = 'Язык'; dsc = function(s) return txtc(''.._l('gui.lang')..'^') end;
				act = function(s) return true end
				};
			obj{
				nam = 'Тема'; dsc = function(s) return txtc('{'.._l('gui.thm')..'}^') end;
				act = function(s) walk(mthemas) 	end
				};
			obj{
				nam = 'Уровень сложности'; dsc = function(s) return txtc('{'.._l('gui.diff')..'}^') end;
				act = function(s) walk(mdiff) 	end
				};
			
			
			obj{
				nam = 'Назад'; dsc = function(s) return txtc('^{'.._l('gui.back')..'}^') end;
				act = function(s) 
					if ui_type == UIT_MENU then walk(main) 
					else walk(m_help)
					end
				end
				};

				
				
	}
};

---

---эпизод 1
ep1menu = room {
	nam = 'Эпизод 1',
	disp = '',
	pic = '',

	entered = function(s) inv_clear(); take_my_stat( txtem(_l('gui.ep1txt'))) end,	
	forcedsc = true,
	dsc = function(s)
	   return '{cheat|'..img('img/'..prefs.thm..'/'..'code10.png')..'}^'
	end,
	--pic = '',
	obj = { 
				obj{
				nam = 'Срочный вызов'; 
				dsc = function(s) 
						local t
						t = '{'.._l('mis.1')..'}'
						if prefs.completed[1] then 
							t=t..' (Боев '..prefs.stat[1]['battle_count']..', итог '..img('img/'..prefs.thm..'/'..'ico_killed.png')..prefs.stat[1]['losses_count']..' '..img('img/'..prefs.thm..'/'..'ico_hit.png')..prefs.stat[1]['frag_count']..')'
						end
						return  txtc(t)..'^' 
					end;
				act = function(s)  
						install_ep1()
						mis_i = 1
						mission_advance();
					end
				};
				--------------------------------------------------------------------------------
				obj{
				nam = ''; 
				dsc = function(s) 
						local t
						t = '{'.._l('mis.2')..'}'
						if prefs.completed[2] then 
							t=t..' (Боев '..prefs.stat[2]['battle_count']..', итог '..img('img/'..prefs.thm..'/'..'ico_killed.png')..prefs.stat[2]['losses_count']..' '..img('img/'..prefs.thm..'/'..'ico_hit.png')..prefs.stat[2]['frag_count']..')'
						end
						if prefs.completed[1] then return  txtc(t)..'^' else return true end
					end;
				act = function(s)  
						install_ep1()
						mis_i = 2
						mission_advance();
					end
				};
				--------------------------------------------------------------------------------
				obj{
				nam = ''; 
				dsc = function(s) 
						local t
						t = '{'.._l('mis.3')..'}'
						if prefs.completed[3] then 
							t=t..' (Боев '..prefs.stat[3]['battle_count']..', итог '..img('img/'..prefs.thm..'/'..'ico_killed.png')..prefs.stat[3]['losses_count']..' '..img('img/'..prefs.thm..'/'..'ico_hit.png')..prefs.stat[3]['frag_count']..')'
						end
						if prefs.completed[2] then return  txtc(t)..'^' else return true end 
					end;
				act = function(s)  
						install_ep1()
						mis_i = 3
						mission_advance();
					end
				};
				--------------------------------------------------------------------------------
				obj{
				nam = ''; 
				dsc = function(s) 
						local t
						t = '{'.._l('mis.4')..'}'
						if prefs.completed[4] then 
							t=t..' (Боев '..prefs.stat[4]['battle_count']..', итог '..img('img/'..prefs.thm..'/'..'ico_killed.png')..prefs.stat[4]['losses_count']..' '..img('img/'..prefs.thm..'/'..'ico_hit.png')..prefs.stat[4]['frag_count']..')'
						end
						if prefs.completed[3] then return  txtc(t)..'^' else return true end 
					end;
				act = function(s)  
						install_ep1()
						mis_i = 4
						mission_advance();
					end
				};
				--------------------------------------------------------------------------------
				obj{
				nam = ''; 
				dsc = function(s) 
						local t
						t = '{'.._l('mis.5')..'}'
						if prefs.completed[5] then 
							t=t..' (Боев '..prefs.stat[5]['battle_count']..', итог '..img('img/'..prefs.thm..'/'..'ico_killed.png')..prefs.stat[5]['losses_count']..' '..img('img/'..prefs.thm..'/'..'ico_hit.png')..prefs.stat[5]['frag_count']..')'
						end
						if prefs.completed[4] then return  txtc(t)..'^' else return true end
					end;
				act = function(s)  
						install_ep1()
						mis_i = 5
						mission_advance();
					end
				};
				--------------------------------------------------------------------------------
				obj{
				nam = ''; 
				dsc = function(s) 
						local t
						t = '{'.._l('mis.6')..'}'
						if prefs.completed[6] then 
							t=t..' (Боев '..prefs.stat[6]['battle_count']..', итог '..img('img/'..prefs.thm..'/'..'ico_killed.png')..prefs.stat[6]['losses_count']..' '..img('img/'..prefs.thm..'/'..'ico_hit.png')..prefs.stat[6]['frag_count']..')'
						end
						if prefs.completed[5] then return  txtc(t)..'^' else return true end 
					end;
				act = function(s)  
						install_ep1()
						mis_i = 6
						mission_advance();
					end
				};
				--------------------------------------------------------------------------------				
				obj{
				nam = ''; 
				dsc = function(s) 
						local t
						t = '{'.._l('mis.7')..'}'
						if prefs.completed[7] then 
							t=t..' (Боев '..prefs.stat[7]['battle_count']..', итог '..img('img/'..prefs.thm..'/'..'ico_killed.png')..prefs.stat[7]['losses_count']..' '..img('img/'..prefs.thm..'/'..'ico_hit.png')..prefs.stat[7]['frag_count']..')'
						end
						if prefs.completed[6] then return  txtc(t)..'^' else return true end 
					end;
				act = function(s)  
						install_ep1()
						mis_i = 7
						mission_advance();
					end
				};
				--------------------------------------------------------------------------------				
				obj{
				nam = ''; 
				dsc = function(s) 
						local t,r
						t = '^'.._l('gui.total')
						r = statistic_calculate()
						
						if prefs.completed[7] then 
							t=t..' (Боев '..r[1]..', '..img('img/'..prefs.thm..'/'..'ico_killed.png')..r[2]..'/'..r[4]..' '..img('img/'..prefs.thm..'/'..'ico_hit.png')..r[3]..')'
						end
						if prefs.completed[7] then return  txtc(t)..'^' else return true end 
					end;
				act = function(s)  
					end
				};				
				
				
				
				--------------------------------------------------------------------------------	
				obj{
				nam = 'Назад'; dsc = function(s) return txtc('^{'.._l('gui.back')..'}^') end;
				act = function(s) walk(main)  end
				};
				
				xact('cheat', function(s) 
									local i
									for i=1,7 do
										prefs.completed[i] = true	
										prefs.stat[i] = prefs.stat[i] or {} 
										prefs.stat[i]['battle_count'] =  prefs.stat[i]['battle_count'] or 0
										prefs.stat[i]['losses_count'] =  prefs.stat[i]['losses_count'] or 0
										prefs.stat[i]['frag_count'] = prefs.stat[i]['frag_count'] or 0
										prefs.stat[i]['hm_count'] = prefs.stat[i]['hm_count'] or 0
									end
									prefs.ep2 = true
									prefs:store()
									return true
						 
							end );
				
				
	}
};

---эпизод 2
ep2menu = room {
	nam = 'Эпизод 2',
	disp = '',
	entered = function(s) inv_clear(); take_my_stat( txtem(_l('gui.ep2txt'))) end,	
	forcedsc = true,
	dsc = function(s)
	   return img('img/'..prefs.thm..'/'..'code10.png')..'^'
	end,
	--pic = '',
	obj = { 
				--------------------------------- сюда добавлять ссылки на новые миссии
				obj{
				nam = 'Максим Котов'; dsc = function(s) return txtc('{'..'Максим Котов, инженерная служба'..'}^')  end;
				act = function(s)  gamefile('ep2/e2m1.lua') 
								   install_umission(e2m1_mis) return true end
				};
							
				
				--------------------------------------------------------------------------------
				obj{
				nam = 'Назад'; dsc = function(s) return txtc('^{'.._l('gui.back')..'}^') end;
				act = function(s) back()  end
				};
				
				
	}
};


--настройки
mdebug = room {
	nam = 'DEBUG',
	disp = '',
	forcedsc = true,
	dsc = function(s)
		if ui_type == UIT_MENU then  return img('img/'..prefs.thm..'/'..'code10.png')..'^' else return true end
	end,
	entered = function(s) 
				inv_clear();   
			end,
	--pic = '',
	obj = { 
			obj{
				nam = 'Локализация'; dsc = function(s) return txtc('{Локализация}^') end;
				act = function(s) return set_locale('ru','ep2/locale.xml')  end
				};
	
			obj{
				nam = 'Статистика'; dsc = function(s) return txtc('{Статистика}^') end;
				act = function(s) 
							local r = {}
							r = statistic_calculate()
							return r[1]..' '..r[2]..' '..r[3]..' '..r[4]..' '
							
							end
				};			
			
			
			
			
			
			obj{
				nam = 'Назад'; dsc = function(s) return txtc('^{'.._l('gui.back')..'}^') end;
				act = function(s) 
					if ui_type == UIT_MENU then walk(main) 
					else walk(m_help)
					end
				end
				};

				
				
	}
};



main = room {
	nam = 'Главное меню',
	disp = '',
	forcedsc = true,
	dsc = function(s)
	   return img('img/'..prefs.thm..'/'..'code10.png')..'^'
	end,
	entered = function(s)  inv_clear(); take_my_stat( txtem(_l('prologue'))..'^^'.._l('prologue2')) end,
	--pic = '',
			
	obj = {  
			obj{
				nam = 'Эпизод 1';
				dsc = function(s) return txtc('{'.._l('gui.ep1')..'}^') end;
				act = function(s)
					walk(ep1menu)
				end
				};
			obj{
				nam = 'Эпизод 2';
				dsc = function(s)  if prefs.ep2 then  return txtc('{'.._l('gui.ep2')..'}^') else return true end end;
				act = function(s)
				walk(ep2menu)
				end
				};
				
				
    		
			obj{
				nam = 'Настройки';
				dsc = function(s) return txtc('{'.._l('gui.set')..'}^') end;
				act = function(s)	
					walk(msettings)
				end
				};
				
				
				--obj{ nam = 'DEBUG';	dsc = function(s) return txtc('{DEBUG}^') end;	act = function(s)	walk(mdebug) end};			
				
				
			obj{nam = 'Информация';dsc = txtc('^^^^^^^^v.1.0');}
			--obj{nam = 'Информация';dsc = txtc('^^^^^Промежуточная версия^Сохранения разрешены^^v.0.11+');}

		}
};

